// MessModel.java                                   MM 2014
// MVC-Model-Grundstruktur

import java.util.*;                   // Observable, Vector
import Tools.IO.*;                          // Testeingaben

/**
 * Mittelwertberechnung von Messwerten.
 */
public class MessModel
  extends Observable
{
/* ----------------------------------------------------- */
/**
 * Messwerte.
 */
  private Vector<Double> liste;

/* ----------------------------------------------------- */

/**
 * Konstruktor, erzeugt neue Liste.
 */
  public MessModel()
  {
    reset();
  }

/* ----------------------------------------------------- */
/**
 * Erzeugt neue Liste.
 */
  public void reset()
  {
    liste = new Vector<Double>();

    setChanged();                     // Aenderung anzeigen
    notifyObservers( liste);
  }

/**
 * Nimmt Messwerte auf.
 * @param wert neuer Messwert
 */
  public void addWert( double wert)
  {
    liste.add( wert);

    setChanged();                     // Aenderung anzeigen
    notifyObservers( liste);
  }

/**
 * Berechnet Mittelwert der Messwerte.
 * @return berechneter Mittelwert
 */
  public double mittelWert()
  {
    double d = 0;
    for( Double werte: liste) d += werte;
    d /= liste.size();

    return d;
  }

/**
 * Gibt Messwerte als String zurck.
 * @return Messwerte als String, zeilenweise
 */
  public String toString()
  {
    String str = "";
    for( Double d: liste) str += d + "\n";

    return str;
  }

/* ----------------------------------------------------- */
/**
 * Testprogramm der Klasse MessModel.
 */
  public static void main( String[] args)
  {
    MessModel model = new MessModel();

    while( true)
    {
      String eingabe = IOTools.readLine
      ( "Naechste Komponente(<ENTER> fuer Abbruch) ");

      if( eingabe.equals( "")) break;

      try
      {
        model.addWert( Double.valueOf( eingabe));
      }
      catch( Exception e)
      {
        System.out.println( "Nur Zahlen eingeben!\n");
      }
    }

    System.out.println();
    System.out.println( "Eingegebenen Werte:");
    System.out.println( model);
    System.out.println( "Berechneter Mittelwert:");
    System.out.println( model.mittelWert());
  }
}
