// Wald.java                                        MM 2014

/**
 * Wald: Schonung,
 * rechteckig gitterfoermig angeordneter Baeume.
 */
public class Wald
{
/**
 * Alle Baeume eines Waldes im Gitter angeordnet.
 */
  private Baum[][] baeume;

/**
 * Konstruktor, erzeugt Wald mit Baeumen.
 */
  public Wald( int laenge, int breite)
  {
    baeume = new Baum[ laenge][ breite];
    for( int i = 0; i < laenge; i++)
      for( int j = 0; j < breite; j++)
        baeume[ i][ j] = new Baum();
  }

/**
 * Lesen der Breite des Waldes.
 */
  public int getBreite()
  {
    return baeume[ 0].length;
  }

/**
 * Lesen der Laenge des Waldes.
 */
  public int getLaenge()
  {
    return baeume.length;
  }

/**
 * Faellen des Baumes an vorgegebener Position.
 */
  public void baumFaellen( int zeile, int spalte)
  throws ArrayIndexOutOfBoundsException
  {
    baeume[ zeile][ spalte].faellen();
  }

/**
 * Schlagen einer Schneise.
 * @param schneise Nummer der zu faellenden Schneise
 * @param laengs true: laengs, false: quer im Wald
 */
  public void schneiseSchlagen
  ( int schneise, boolean laengs)
  throws ArrayIndexOutOfBoundsException
  {
    if( laengs)
    for( int j = 0; j < baeume[ schneise].length; j++)
      baeume[ schneise][ j].faellen();
    else
    for( int i = 0; i < baeume.length; i++)
      baeume[ i][ schneise].faellen();
  }

/**
 * Rasterdarstellung des Waldes,
 * x Baum, o gefaellter Baum.
 */
  public String toString()
  {
    String str = "";
    for( int i = 0; i < baeume.length; i++)
    {
      for( int j = 0; j < baeume[ 0].length; j++)
        str += " " + baeume[ i][ j].toString();
      str += "\n";
    }
    return str;
  }
}