// Wuerfel.java                                     MM 2014

import java.awt.*;                                 // Color
import javax.swing.*;              //JFrame, JPanel, JLabel
import java.awt.event.*;                        // Listener

/**
 * Wuerfel 1..6.
 */
public class Wuerfel
  extends JFrame
  implements ActionListener
{
/* ----------------------------------------------------- */
                                                    // View
/**
 * Konstante, Wuerfeln.
 */
  static public String ACTION_WURF = "Wurf";

/**
 * Konstante, Beenden des Programms.
 */
  static public String ACTION_ENDE = "Ende";

/**
 * Label, fuer Augenzahl.
 */
  private JLabel lbAugen;

/**
 * Konstruktor, baut das Fenster auf.
 * @param titel Titelleistentext
 * @param farbe Fensterhintergrundsfarbe
 */
  public Wuerfel( String titel, Color farbe)
  {
// Titelleiste
    super( titel);

// Darstellungsbereich
    JPanel contentPane = new JPanel();
    contentPane.setBackground( farbe);
                                             // Button Wurf
    JButton btWurf = new JButton( ACTION_WURF);
    contentPane.add( btWurf);
    btWurf.addActionListener( this);
                                         // Label Augenzahl
    lbAugen = new JLabel( "0");
    contentPane.add( lbAugen);
                                             // Button Quit
    JButton btQuit = new JButton( ACTION_ENDE);
    contentPane.add( btQuit);
    btQuit.addActionListener( this);

// Fenster
    setContentPane( contentPane);
    pack();
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE);
    setVisible( true);
  }

/**
 * Konstruktor mir festen Parametern.
 */
  public Wuerfel()
  {
    this( "Wuerfel", Color.white);
  }

/* ----------------------------------------------------- */
                                              // Controller
/**
 * Ereignisverarbeitung, ActionListener,
 * Betaetigen eines Button.
 */
  public void actionPerformed( ActionEvent ae)
  {
    String command = ae.getActionCommand();

// Wuerfeln
    if( command.equals( ACTION_WURF))
    {
      int zahl = ( int)( Math.random() * 6 + 1);
      lbAugen.setText( "" + zahl);
    }

// Programmabbruch
    if( command.equals( ACTION_ENDE))
    {
      System.exit( 0);
    }
  }

/* ----------------------------------------------------- */
/**
 * Start des Programms.
 */
  public static void main(String args[])
  {
    Wuerfel wurfel = new Wuerfel();
  }
}
